package dammfine.dict;

import java.io.IOException;
import java.io.BufferedReader;

/**
 * Defines a command that can be received from the server.  Generally
 * commands should work both as factories and as instances.
 */
public interface ReceivingCommand
{
	/**
	 * The status code that this command represents.
	 */
	Integer getStatusCode();
	
	/**
	 * Reads data until all data for this command is read, and returns
	 * a copy with all data filled in.
	 */
	ReceivingCommand parse( String firstLine, BufferedReader reader )
		throws IOException;
	
	boolean isPositivePreliminary();
	boolean isPositiveIntermediate();
	boolean isPositiveCompletion();
	
	boolean isNegative();
	boolean isTransientNegative();
	boolean isPermanentNegative();
	
	
}

