package dammfine.dict;

import java.util.Map;
import java.util.HashMap;

import dammfine.dict.receiving.*;

public class ReceivingCommandRegistry
{
	/**
	 * Maps the response codes to the commands.
	 */
	private Map commands;
	
	/**
	 * By default loads the known commands.
	 */
	public ReceivingCommandRegistry()
	{
		// Register commands.
		commands = new HashMap();
		
		addCommand( new OkCommand() );
		addCommand( new ByeCommand() );
		addCommand( new ServerInfoCommand() );
		addCommand( new NoMatchCommand() );
		addCommand( DatabasesPresentCommand.getFactory() );
		addCommand( DefinitionsPresentCommand.getFactory() );
		addCommand( DefinitionCommand.getFactory() );
		addCommand( new NoDatabasesCommand() );
	}

	private void addCommand( ReceivingCommand rCmd )
	{
		commands.put( rCmd.getStatusCode(), rCmd );
	}

	public ReceivingCommand getCommand( Integer responseCode )
	{
		return (ReceivingCommand)commands.get( responseCode );
	}
}

