package dammfine.dict.receiving;

import java.io.IOException;
import java.io.BufferedReader;
import java.util.Map;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.List;
import dammfine.dict.ReceivingCommand;

public class DatabasesPresentCommand extends GenericReceivingTextCommand
{
	private static final Integer statNum = new Integer( 110 );

	private List databases;
	
	/**
	 * This is used to make a factory.
	 */
	private DatabasesPresentCommand()
	{
		this.databases = null;
	}
	
	public DatabasesPresentCommand( List databases )
	{
		this.databases = databases;
	}
	
	public static DatabasesPresentCommand getFactory()
	{
		return new DatabasesPresentCommand();
	}
	
	public Integer getStatusCode()
	{
		return statNum;
	}

	public List getDatabases()
	{
		return databases;
	}
	 
	public ReceivingCommand parse( String lineOne, BufferedReader reader )
		throws IOException
	{
		StringTokenizer tokens = new StringTokenizer( lineOne );
		tokens.nextToken(); // Skip the '110'
		int numDbs = Integer.parseInt( tokens.nextToken() );
		
		List lines = readCommandText( reader );
		
		return new DatabasesPresentCommand( lines );
	}
}
