package dammfine.dict.receiving;

import java.io.IOException;
import java.io.BufferedReader;
import java.util.Map;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.List;
import dammfine.dict.ReceivingCommand;

public class DefinitionsPresentCommand extends GenericReceivingTextCommand
{
	private static final Integer statNum = new Integer( 150 );
	private int numDefinitions = -1;
	
	/**
	 * This is used to make a factory.
	 */
	private DefinitionsPresentCommand()
	{
	}
	
	private DefinitionsPresentCommand( int nDefs )
	{
		this.numDefinitions = nDefs;
	}

	public static DefinitionsPresentCommand getFactory()
	{
		return new DefinitionsPresentCommand();
	}
	
	public int getNumDefinitions()
	{
		return numDefinitions;
	}
	 
	public Integer getStatusCode()
	{
		return statNum;
	}

	public ReceivingCommand parse( String lineOne, BufferedReader reader )
		throws IOException
	{
		StringTokenizer tokens = new StringTokenizer( lineOne );
		tokens.nextToken(); // Skip the '150'
		int numDefs = Integer.parseInt( tokens.nextToken() );
		
		return new DefinitionsPresentCommand( numDefs );
	}
}

