package dammfine.dict.receiving;

import dammfine.dict.ReceivingCommand;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.EOFException;
import java.util.List;
import java.util.Vector;

public abstract class GenericReceivingCommand implements ReceivingCommand
{
	/**
	 * Returns a list of lines in the text.
	 */
	public List readCommandText( BufferedReader reader )
		throws IOException
	{
		List result = new Vector();

		readCommandText( reader, result );

		return result;
	}
	
	public void readCommandText( BufferedReader reader, List appendTo )
		throws IOException
	{
		String line = null;
		while( (line = reader.readLine()) != null )
		{
			// Done.
			if( line.equals( "." ) )
			{
				return;
			}
			else
			{
				appendTo.add( line );
			}
		}
		// Unexpected end of stream
		throw new EOFException();
	}
	 
	public boolean isPositivePreliminary()
	{
		int v = getStatusCode().intValue();
		return v >= 100 && v < 200 ;
	}
	public boolean isPositiveIntermediate()
	{
		int v = getStatusCode().intValue();
		return v >= 300 && v < 400 ;
	}
	public boolean isPositiveCompletion()
	{
		int v = getStatusCode().intValue();
		return v >= 200 && v < 300 ;
	}
	
	public boolean isNegative()
	{
		return isTransientNegative() || isPermanentNegative();
	}
	public boolean isTransientNegative()
	{
		int v = getStatusCode().intValue();
		return v >= 400 && v < 500 ;
	}
	public boolean isPermanentNegative()
	{
		int v = getStatusCode().intValue();
		return v >= 500 && v < 600 ;
	}
}

