package dammfine.dict.sending;

import java.io.IOException;
import dammfine.dict.SendingCommand;
import dammfine.dict.ReceivingCommand;

import dammfine.dict.receiving.OkCommand;
import dammfine.dict.receiving.NoMatchCommand;

public class DefineCommand implements SendingCommand
{
	private String database;
	private String word;

	public DefineCommand( String database, String word )
	{
		this.database = database;
		this.word = word;
	}

	public String render()
	{
		return "DEFINE " + database + " " + word;
	}
	
	public boolean isTerminator( ReceivingCommand cmd )
	{
		return
			cmd instanceof OkCommand ||
			cmd instanceof NoMatchCommand;
	}
}
