package dammfine.jife;

import java.util.Properties;
import java.util.List;

/**
 * Provides support for chaning of suggestion sources, essentially
 * creating filters.
 */
public class ChainedSuggestionSource implements SuggestionSource
{
	private String chainedToName;
	private SuggestionSource chainedTo;
	
	public void init( String name, Properties p )
		throws BadConfigException
	{
		String pName = name + ".chainedTo";
		chainedToName = p.getProperty( pName );
		if( chainedToName == null )
		{
			throw new BadConfigException( pName + " not specified." );
		}
		chainedTo = (SuggestionSource)Jife.loadSource( chainedToName, p );
	}
	
	public List getSuggestions( String word )
		throws JifeException
	{
		return chainedTo.getSuggestions( word );
	}
}
