package dammfine.jife;

import f00f.net.irc.martyr.Debug;

import java.sql.Driver;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.SQLException;

import java.util.Properties;

public class DBUtils
{
	public static String escapeSQL( String str )
	{
		StringBuffer build = new StringBuffer("");
		int apos;
		
		while( (apos=str.indexOf('\'')) >= 0 )
		{
			build.append( str.substring(0, apos) );
			build.append( "\\'" );
			str = str.substring(apos+1);
		}

		// Now append whatever is remaining.
		build.append( str );

		return build.toString();
	}
	public static Connection getDBConnection( Object onBehalfOf, Properties props )
		throws BadConfigException
	{
		String uName = props.getProperty( "db_user" );
		String pWord = props.getProperty( "db_password" );
		String jdbcUrl = props.getProperty( "db_url" );
		String driverClassName = props.getProperty( "db_driver" );
		
		if( uName == null )
			throw new BadConfigException("Missing db_user" );
		if( pWord == null )
			throw new BadConfigException("Missing db_password" );
		if( jdbcUrl == null )
			throw new BadConfigException("Missing db_url" );
		if( driverClassName == null )
			throw new BadConfigException("Missing db_driver" );
		
		Class driverClass;
		
		try
		{
			driverClass = Class.forName( driverClassName );
		} catch( ClassNotFoundException cnfe )
		{
			throw new BadConfigException( "" + cnfe );
		}
		
		Properties dbProps = new Properties();
		dbProps.put( "user", uName );
		dbProps.put( "password", pWord );
		
		Debug.println( onBehalfOf, "Connecting to database.", Debug.EXCESSIVE );
		Driver driver;
		try
		{
			driver = (Driver)driverClass.newInstance();
		} catch( InstantiationException ie )
		{
			throw new BadConfigException( "" + ie );
		} catch( IllegalAccessException iae )
		{
			throw new BadConfigException( "" + iae );
		}
		Connection dbConnection;
		try
		{
			dbConnection = driver.connect( jdbcUrl, dbProps );
		} catch( SQLException sqle )
		{
			throw new BadConfigException( "" + sqle );
		}
		
		if( dbConnection == null )
		{
			throw new BadConfigException( "Error connecting to "
				+ "database: no connection returned from connect!" );
		}

		return dbConnection;
	}

}
