package dammfine.jife;

import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;
import java.util.Properties;

public class LevenshteinFilterSource extends ChainedSuggestionSource
{
	public void init( String name, Properties p )
		throws BadConfigException
	{
		super.init( name, p );
	}
	
	public List getSuggestions( String word )
		throws JifeException
	{
		// We want to re-order according to the LD.
		List superList = super.getSuggestions( word );

		// Now, for each words given, we'll alter the score depending
		// on it's LD.
		List newList = new LinkedList();

		Iterator i = superList.iterator();
		while( i.hasNext() )
		{
			SuggestedWord suggwordO = (SuggestedWord)i.next();
			String suggWord = suggwordO.getSuggested();
			int ld = LevenshteinDistance.LD( word, suggWord );
			// Average the scores.
			float localScore = (float)ld / suggWord.length();
			float newScore = (suggwordO.getScore() + localScore)/2.0f;
			
			SuggestedWord newEntry = new SuggestedWord(word, suggWord, newScore );
			newList.add( newEntry );
		}
		
		Collections.sort( newList );
		
		return newList;
	}
}
