package dammfine.jife;

import f00f.net.irc.martyr.Debug;

import java.sql.Driver;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.SQLException;
import java.util.Properties;
import java.util.List;
import java.util.LinkedList;

import dammfine.util.Metaphone;

public class MetaphoneDataSource implements SuggestionSource
{
	private Connection dbConnection;
	private String name;
	
	public void init( String name, Properties props )
		throws BadConfigException
	{
		this.name = name;
		
		dbConnection = DBUtils.getDBConnection( this, props );
	}
	
	
	public List getSuggestions( String word )
		throws JifeException
	{
		String encodedWord = 
			Metaphone.metaPhone( word ).toString();
		
		Debug.println( this, "Checking: " + word + " metaphone: " + encodedWord, Debug.VERBOSE );

		try
		{
			Statement stmt = dbConnection.createStatement();
			ResultSet resultSet = stmt.executeQuery( 
				"select word,frequency from wordlist where metaphone='" + encodedWord + "'"
					+ " order by frequency asc"
			);
			
			List results = new LinkedList();
			while( resultSet.next() )
			{
				float score = resultSet.getInt(2)/100.0f;
				String suggestion = resultSet.getString(1);
				
				SuggestedWord item = new SuggestedWord( word, suggestion, score );
				results.add( item );
			}

			return results;
			
		}
		catch( SQLException sqle )
		{
			System.err.println( "Error looking up " + word + " (" + encodedWord + ")" );
			System.err.println( sqle );
			throw new JifeException( "Sorry, we appear to be having database problems." );
		}
	}

	public String toString()
	{
		return "MetaphoneDataSource[" + name + "]";
	}
}


