package dammfine.jife;

import java.util.Set;
import java.util.Iterator;
import java.util.Properties;
import java.util.Collections;
import java.util.StringTokenizer;

import f00f.net.irc.martyr.util.FullNick;

public class SetCommand implements JifeCommand
{
	private Jife jife = null;

	public SetCommand( Jife jife )
	{
		this.jife = jife;
	}
	 
	public void processCommand( String cmd, FullNick sender, String replyTo, String input, boolean toGroup )
		throws JifeException
	{
		Properties p = jife.getUserProperties( sender );
		StringTokenizer tokens = new StringTokenizer( input );
		
		// Strip off the command.
		tokens.nextToken();
		if( tokens.countTokens() == 0 )
		{
			Iterator pI = p.keySet().iterator();
			
			jife.sendTo( sender, "Your settings:" );
			while( pI.hasNext() )
			{
				String key = (String)pI.next();
				String value = (String)p.get( key );

				jife.sendTo( sender, "  " + key + " = " + value );
			}
		}
		else if( tokens.countTokens() == 2 )
		{
			String key = tokens.nextToken();
			String value = tokens.nextToken();

			p.put( key, value );
		}
		else 
		{
			jife.sendTo( sender, "Either key value, or nothing." );
		}

	}

	public void sendHelp( String replyTo, String input )
	{
		jife.sendTo( replyTo, "The set command has two functions:" );
		jife.sendTo( replyTo, "	1) \"set\" with no parameters shows the currently set variables." );
		jife.sendTo( replyTo, "	2) \"set <variable> <value>\" sets the value of a variable." );
	}

	/**
	 * Returns a set of strings that represents the commands this
	 * command would like to respond to.
	 */
	public Set getCommandSet()
	{
		return Collections.singleton( "set" );
	}
	/**
	 * @return a short summary of what this command does.
	 */
	public String getSummary()
	{
		return "Provides access to variables.";
	}
}
