package dammfine.jife;

import java.util.List;
import java.util.Properties;
/**
 * A Source is a source for data.  Seed data to provide
 * on is given, and data is returned, on some other interface.
 * 
 * A Source is guaranteed to have its init method called
 * before any call.  init will not be called more
 * than once for any given instance of a source.
 */
public interface Source
{
	/**
	 * sourceName is the name for this instance of the source.
	 */
	void init( String sourceName, Properties p ) throws BadConfigException;
}

