package dammfine.jife;

/**
 * A suggestion for a word, containing the suggestion, the score, and
 * the original word.
 */
public class SuggestedWord implements Comparable
{
	private String original;
	private String suggested;
	private float score;
	
	public SuggestedWord( String original, String suggested, float score )
	{
		this.original = original;
		this.suggested = suggested;
		this.score = score;
	}
	
	public String getOriginal()
	{
		return original;
	}

	public String getSuggested()
	{
		return suggested;
	}

	public String toString()
	{
		return getSuggested();
	}

	public float getScore()
	{
		return score;
	}

	public boolean equals( Object o )
	{
		if( o instanceof SuggestedWord )
		{
			return compareTo( o ) == 0;
		}
		else
		{
			return false;
		}
	}

	public int compareTo( Object o )
	{
		SuggestedWord other = (SuggestedWord)o;

		return (int)((this.score - other.score) * 10000);
	}
}
