package dammfine.jife;

import java.util.List;
import java.util.Properties;
/**
 * A SuggestionSource is a source for suggestions.  A word to provide
 * suggestions on is given, and a list of suggestions, with most
 * relevant first, is returned.  Each element in the list must be a
 * SuggestedWord object.
 * 
 * A SuggestionSource is guaranteed to have its init method called
 * before any call to getSuggestions.  init will not be called more
 * than once for any given instance of a suggestion source.
 */
public interface SuggestionSource extends Source
{
	List getSuggestions( String word ) throws JifeException;
}

