package dammfine.jife;

import java.util.List;
import java.util.LinkedList;
import java.util.Iterator;
import java.util.Properties;

public class TruncateSource extends ChainedSuggestionSource
{
	int stopAt;
	
	public void init( String name, Properties p )
		throws BadConfigException
	{
		super.init( name, p );

		String pName = name + ".num";

		if( p.getProperty( pName ) == null )
		{
			throw new BadConfigException( pName + " not defined." );
		}
		try
		{
			stopAt = Integer.parseInt( p.getProperty( pName ) );
		}
		catch( NumberFormatException nfe )
		{
			throw new BadConfigException( pName + " not a number." );
		}
	}
	
	public List getSuggestions( String word )
		throws JifeException
	{
		// We want to re-order according to the LD.
		List superList = super.getSuggestions( word );
		
		List newList = new LinkedList();
		
		int counter = 0;
		Iterator old = superList.iterator();
		while( old.hasNext() && counter++ != stopAt )
		{
			newList.add( old.next() );
		}

		return newList;
	}
	
}
